Use the Cloud Product Registry remote MCP server

This document shows you how to use the Cloud Product Registry remote Model Context Protocol (MCP) server to connect with AI applications including Gemini CLI, ChatGPT, Claude, and custom applications you are developing. The Cloud Product Registry remote MCP server lets your AI applications and agents programmatically discover and retrieve authoritative metadata about first-party Google Cloud Product Suites, Logical Products, and Logical Product Variants, including their titles, lifecycle states, and restructuring replacements. The Cloud Product Registry remote MCP server is enabled when you enable the Cloud Product Registry API.

Model Context Protocol (MCP) standardizes how large language models (LLMs) and AI applications or agents connect to external data sources. MCP servers let you use their tools, resources, and prompts to take actions and get updated data from their backend service.

What's the difference between local and remote MCP servers?

Local MCP servers
Typically run on your local machine and use the standard input and output streams (stdio) for communication between services on the same device.
Remote MCP servers
Run on the service's infrastructure and offer an HTTP endpoint to AI applications for communication between the AI MCP client and the MCP server. For more information about MCP architecture, see MCP architecture.

Stateless core

With MCP version 2026-07-28, MCP changes from a bidirectional, stateful protocol to a stateless protocol. Each MCP request is self-describing and can be routed using headers. There isn't a need for the initialize/initialized handshake or Mcp-Session-Id because each request includes all the information needed in HTTP headers or the _meta parameter. MCP servers can request additional information required by a tool through multi-round-trip requests (MRTR).

To help route and process requests without parsing the request body, some MCP headers are required, including the following:

  • Headers that are required by the MCP specification such as the protocol version header and standard request headers.
  • Custom headers that are defined by the MCP server. These headers are mirrored into HTTP headers from the tool's input schema using the x-mcp-header property. For example, an MCP server might define a custom header to specify the Google Cloud region or project ID.

For more information about MCP architecture, see the MCP version 2026-07-28 specification and key changes.

Google and Google Cloud remote MCP servers

Google and Google Cloud remote MCP servers have the following features and benefits:

  • Simplified, centralized discovery
  • Managed global or regional HTTP endpoints
  • Fine-grained authorization
  • Optional prompt and response security with Model Armor protection
  • Centralized audit logging

For information about other MCP servers and information about security and governance controls available for Google Cloud MCP servers, see Google Cloud MCP servers overview.

Before you begin

  1. Sign in to your Google Cloud account. If you're new to Google Cloud, create an account to evaluate how our products perform in real-world scenarios. New customers also get $300 in free credits to run, test, and deploy workloads.
  2. In the Google Cloud console, on the project selector page, select or create a Google Cloud project.

    Roles required to select or create a project

    • Select a project: Selecting a project doesn't require a specific IAM role—you can select any project that you've been granted a role on.
    • Create a project: To create a project, you need the Project Creator role (roles/resourcemanager.projectCreator), which contains the resourcemanager.projects.create permission. Learn how to grant roles.

    Go to project selector

  3. Enable the Cloud Product Registry API, if it is not already enabled.

    Roles required to enable APIs

    To enable APIs, you need the serviceusage.services.enable permission. If you created the project, then you likely already have this permission through the Owner role (roles/owner). Otherwise, you can get this permission through the Service Usage Admin role (roles/serviceusage.serviceUsageAdmin). Learn how to grant roles.

    Enable the API

  4. In the Google Cloud console, on the project selector page, select or create a Google Cloud project.

    Roles required to select or create a project

    • Select a project: Selecting a project doesn't require a specific IAM role—you can select any project that you've been granted a role on.
    • Create a project: To create a project, you need the Project Creator role (roles/resourcemanager.projectCreator), which contains the resourcemanager.projects.create permission. Learn how to grant roles.

    Go to project selector

  5. Enable the Cloud Product Registry API, if it is not already enabled.

    Roles required to enable APIs

    To enable APIs, you need the serviceusage.services.enable permission. If you created the project, then you likely already have this permission through the Owner role (roles/owner). Otherwise, you can get this permission through the Service Usage Admin role (roles/serviceusage.serviceUsageAdmin). Learn how to grant roles.

    Enable the API

Authentication

Because the Cloud Product Registry API exposes public Google Cloud product catalog data and doesn't require a principal, the Cloud Product Registry remote MCP server authenticates requests using API keys only. It doesn't use OAuth 2.0 or require project-level Identity and Access Management (IAM) roles to call MCP tools.

To create an API key for an AI application, do the following:

  1. In the Google Cloud console, go to the APIs & Services > Credentials page.

    Go to Credentials

  2. Click Create credentials and then select API key.

  3. In the API key created dialog, click Edit API key.

    1. Edit the API key Application restrictions to limit the key's usage to authorized environments.
    2. Under API restrictions, select Restrict key and choose Cloud Product Registry API.
  4. Click Save.

To keep your API key secure, follow the best practices for securely using API keys.

For more information about authenticating to MCP servers with an API key, see Authenticate with an API key.

Configure an MCP client to use the Cloud Product Registry MCP server

AI applications and agents, such as Claude or Antigravity, can instantiate an MCP client that connects to a single MCP server. An AI application can have multiple clients that connect to different MCP servers. If your application isn't listed in the client-specific guidance, then you can use the following information to connect from most applications.

In your AI application, look for a way to add or connect to a remote MCP server. For the Cloud Product Registry MCP server, enter the following information as required:

  • Server name: Cloud Product Registry MCP server
  • Server URL or Endpoint: https://cloudproductregistry.googleapis.com/mcp
  • Transport: Streamable HTTP
  • Authentication details: Pass your Google Cloud API key in the X-Goog-Api-Key request header. For example:

    {
      "mcpServers": {
        "cloud-product-registry": {
          "serverUrl": "https://cloudproductregistry.googleapis.com/mcp",
          "headers": {
            "X-Goog-Api-Key": "GOOGLE_API_KEY"
          }
        }
      }
    }
    

    For more information about authentication, see Authenticate to MCP servers.

For application-specific guidance about setting up and connecting to MCP server, see Client-specific guidance.

For more general guidance, see the following resources:

Available tools

To view details of available MCP tools and their descriptions for the Cloud Product Registry MCP server, see the Cloud Product Registry MCP reference.

List tools

Use the MCP inspector to list tools, or send a tools/list HTTP request directly to the Cloud Product Registry remote MCP server. The tools/list method doesn't require authentication.

curl -X POST https://cloudproductregistry.googleapis.com/mcp \
    -H 'Content-Type: application/json' \
    -H 'Accept: application/json' \
    -H 'MCP-Protocol-Version: MCP_PROTOCOL_VERSION' \
    -H 'Mcp-Method: tools/list' \
    -d '{
      "jsonrpc": "2.0",
      "id": 1,
      "method": "tools/list",
      "params": {
        "_meta": {
          "io.modelcontextprotocol/protocolVersion": "MCP_PROTOCOL_VERSION",
          "io.modelcontextprotocol/clientCapabilities": {
            "extensions": {
              "io.modelcontextprotocol/ui": {
                "mimeTypes": ["text/html;profile=mcp-app"]
              }
            }
          }
        }
      }
    }'

Replace the following:

  • MCP_PROTOCOL_VERSION: The MCP protocol version. For example, 2026-07-28.

Example use cases

The following are example use cases for the Cloud Product Registry MCP server:

Use case Prompt examples
Discovering Google Cloud Product Suites and Logical Products in the official catalog. "List the available Google Cloud product suites and show the logical products under the Google Cloud suite."
Inspecting Logical Product Variants for a Logical Product. "What variants are available for Cloud SQL, and what are their official titles and lifecycle states?"
Checking product lifecycle states and restructuring replacements. "Look up the lifecycle state for logicalProducts/2A8F9B3C-1D4E-5F6A-7B8C-9D0E1F2A3B4C and check whether it has been replaced by another entity."

What's next